var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.taskRnvConfigSet=exports.updateConfig=exports.setAppConfig=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));
var _path=_interopRequireDefault(require("path"));
var _fs=_interopRequireDefault(require("fs"));
var _deepmerge=_interopRequireDefault(require("deepmerge"));
var _util=require("util");
var _inquirer=_interopRequireDefault(require("inquirer"));
var _constants=require("../core/constants");














var _engineManager=require("../core/engineManager");

var _utils=require("../core/utils");

var _fileutils=require("../core/systemManager/fileutils");

















var _common=require("../core/common");

var _workspace=require("../core/projectManager/workspace");
var _logger=require("../core/systemManager/logger");








var _projectParser=require("../core/projectManager/projectParser");



var _prompt=require("../cli/prompt");
var _pluginManager=require("../core/pluginManager");

var base=_path.default.resolve('.');
var homedir=require('os').homedir();

var readdirAsync=(0,_util.promisify)(_fileutils.fsReaddir);


var _loadAppConfigIDfromDir=function _loadAppConfigIDfromDir(dir,appConfigsDir){
(0,_logger.logDebug)("_loadAppConfigIDfromDir:"+dir+":"+appConfigsDir,(0,_logger.chalk)().grey);
var filePath=_path.default.join(appConfigsDir,dir,'renative.json');
if((0,_fileutils.fsExistsSync)(filePath)){
try{
var renativeConf=JSON.parse((0,_fileutils.fsReadFileSync)(filePath));
return{dir:dir,id:renativeConf.id};
}catch(e){
(0,_logger.logError)("File "+filePath+" is MALFORMED:\n"+e);
}
}
return{dir:dir,id:null};
};

var _findAndSwitchAppConfigDir=function _findAndSwitchAppConfigDir(c,appId){var _c$buildConfig$paths,_c$buildConfig$paths2;
(0,_logger.logTask)('_findAndSwitchAppConfigDir',"appId:"+appId);

c.paths.project.appConfigsDir=(0,_fileutils.getRealPath)(
c,(_c$buildConfig$paths=
c.buildConfig.paths)==null?void 0:_c$buildConfig$paths.appConfigsDir,
'appConfigsDir',
c.paths.project.appConfigsDir);

var appConfigsDirs=(_c$buildConfig$paths2=c.buildConfig.paths)==null?void 0:_c$buildConfig$paths2.appConfigsDirs;
if(appConfigsDirs&&appConfigsDirs.forEach&&appId){
appConfigsDirs.forEach(function(v){
var altPath=_path.default.join(v,appId);
if((0,_fileutils.fsExistsSync)(altPath)){
(0,_logger.logInfo)("Found config in following location: "+
altPath+". Will use it");

c.paths.project.appConfigsDir=v;
}
});
}
};

var setAppConfig=function setAppConfig(c,appId){var _c$program$appConfigI,_c$files$project,_c$files$project$conf,_c$files$project$conf2,aid;return _regenerator.default.async(function setAppConfig$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('setAppConfig',"appId:"+appId);if(!(

!appId||appId===true||appId===true)){_context.next=3;break;}return _context.abrupt("return");case 3:

c.runtime.appId=appId;
c.runtime.appDir=_path.default.join(
c.paths.project.builds.dir,
c.runtime.appId+"_"+c.platform);


_findAndSwitchAppConfigDir(c,appId);

parseRenativeConfigs(c);if(!(

c.program.appConfigID!==true)){_context.next=12;break;}_context.next=10;return _regenerator.default.awrap(
matchAppConfigID(
c,(_c$program$appConfigI=
c.program.appConfigID)==null?void 0:_c$program$appConfigI.toLowerCase==null?void 0:_c$program$appConfigI.toLowerCase()));case 10:aid=_context.sent;

c.runtime.appId=aid||
c.runtime.appId||((_c$files$project=
c.files.project)==null?void 0:(_c$files$project$conf=_c$files$project.configLocal)==null?void 0:(_c$files$project$conf2=_c$files$project$conf._meta)==null?void 0:_c$files$project$conf2.currentAppConfigId);case 12:case"end":return _context.stop();}}},null,null,null,Promise);};exports.setAppConfig=setAppConfig;











































var updateConfig=function updateConfig(c,appConfigId){var isPureRnv,configDirs,_await$inquirerPrompt,_conf,_await$inquirerPrompt2,conf;return _regenerator.default.async(function updateConfig$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)('updateConfig',"appId:"+appConfigId);_context2.next=3;return _regenerator.default.awrap(

setAppConfig(c,appConfigId));case 3:

isPureRnv=!c.command&&!c.subCommand;if(!(

!(0,_fileutils.fsExistsSync)(c.paths.appConfig.dir)||isPureRnv)){_context2.next=30;break;}
configDirs=listAppConfigsFoldersSync(c,true);

if(!appConfigId){
(0,_logger.logWarning)("It seems you don't have any appConfig active");
}else if(appConfigId!==true&&appConfigId!==true&&!isPureRnv){
(0,_logger.logWarning)("It seems you don't have appConfig named "+
(0,_logger.chalk)().white(
appConfigId)+" present in your config folder: "+
(0,_logger.chalk)().white(
c.paths.project.appConfigsDir)+" !\nchecked path: "+

c.paths.appConfig.dir);

}if(!

configDirs.length){_context2.next=21;break;}if(!(
configDirs.length===1)){_context2.next=13;break;}

(0,_logger.logInfo)("Found only one app config available. Will use "+
(0,_logger.chalk)().white(
configDirs[0]));_context2.next=12;return _regenerator.default.awrap(


setAppConfig(c,configDirs[0]));case 12:return _context2.abrupt("return",
true);case 13:_context2.next=15;return _regenerator.default.awrap(


(0,_prompt.inquirerPrompt)({
name:'conf',
type:'list',
message:'Which one would you like to pick?',
choices:configDirs,
pageSize:50,
logMessage:'ReNative found multiple existing appConfigs'}));case 15:_await$inquirerPrompt=_context2.sent;_conf=_await$inquirerPrompt.conf;if(!


_conf){_context2.next=21;break;}_context2.next=20;return _regenerator.default.awrap(
setAppConfig(c,_conf));case 20:return _context2.abrupt("return",
true);case 21:_context2.next=23;return _regenerator.default.awrap(



(0,_prompt.inquirerPrompt)({
name:'conf',
type:'confirm',
message:'Do you want ReNative to create new sample appConfig for you?',
warningMessage:"No app configs found for this project \nMaybe you forgot to run "+(0,_logger.chalk)().white('rnv template apply')+" ?"}));case 23:_await$inquirerPrompt2=_context2.sent;conf=_await$inquirerPrompt2.conf;if(!


conf){_context2.next=30;break;}_context2.next=28;return _regenerator.default.awrap(

(0,_engineManager.executeTask)(c,_constants.TASK_TEMPLATE_APPLY));case 28:_context2.next=30;return _regenerator.default.awrap(

setAppConfig(c));case 30:return _context2.abrupt("return",


true);case 31:case"end":return _context2.stop();}}},null,null,null,Promise);};exports.updateConfig=updateConfig;



var matchAppConfigID=function matchAppConfigID(c,appConfigID){var _c$buildConfig,_c$buildConfig$paths3,_c$paths$project;var appConfigsDirs,_loop,i,_ret;return _regenerator.default.async(function matchAppConfigID$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
(0,_logger.logTask)('matchAppConfigID',"appId:"+appConfigID);if(

appConfigID){_context5.next=3;break;}return _context5.abrupt("return",false);case 3:

appConfigsDirs=((_c$buildConfig=c.buildConfig)==null?void 0:(_c$buildConfig$paths3=_c$buildConfig.paths)==null?void 0:_c$buildConfig$paths3.appConfigsDirs)||[(_c$paths$project=
c.paths.project)==null?void 0:_c$paths$project.appConfigsDir];_loop=function _loop(



i){var appConfigsDir,appConfigDirContents,appConfigs,ids,dirs,foundConfig;return _regenerator.default.async(function _loop$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
appConfigsDir=appConfigsDirs[i];if(!
(0,_fileutils.fsExistsSync)(appConfigsDir)){_context4.next=17;break;}_context4.t0=_regenerator.default;_context4.next=5;return _regenerator.default.awrap(
readdirAsync(
appConfigsDir));case 5:_context4.t1=_context4.sent.
filter(function(folder){return(0,_fileutils.fsStatSync)(_path.default.join(appConfigsDir,folder)).isDirectory();});_context4.next=8;return _context4.t0.awrap.call(_context4.t0,_context4.t1);case 8:appConfigDirContents=_context4.sent;

appConfigs=appConfigDirContents.
map(function(dir){return _loadAppConfigIDfromDir(dir,appConfigsDir);}).
filter(function(conf){return conf.id!==null;});

ids=[];
dirs=[];_context4.next=14;return _regenerator.default.awrap(
Promise.all(
appConfigs.map(function _callee(conf){var id,dir;return _regenerator.default.async(function _callee$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
id=conf.id.toLowerCase();
dir=conf.dir.toLowerCase();if(!(

id!==dir)){_context3.next=5;break;}_context3.next=5;return _regenerator.default.awrap(
askUserAboutConfigs(
c,
conf.dir,
conf.id,
appConfigsDir));case 5:if(!


ids.includes(id)){_context3.next=7;break;}throw(
new Error("AppConfig error - You have 2 duplicate app configs with ID "+

id+". Keep in mind that ID is case insensitive.\nPlease edit one of them in /appConfigs/<folder>/renative.json"));case 7:




ids.push(id);if(!
dirs.includes(dir)){_context3.next=10;break;}throw(
new Error("AppConfig error - You have 2 duplicate app config folders named "+

dir+". Keep in mind that folder names are case insensitive.\nPlease rename one /appConfigs/<folder>"));case 10:




dirs.push(dir);case 11:case"end":return _context3.stop();}}},null,null,null,Promise);})));case 14:



foundConfig=appConfigs.filter(
function(cfg){return cfg.id===appConfigID||
cfg.id.toLowerCase()===appConfigID||
cfg.dir===appConfigID||
cfg.dir.toLowerCase()===appConfigID;});if(!

foundConfig.length){_context4.next=17;break;}return _context4.abrupt("return",{v:foundConfig[0].id.toLowerCase()});case 17:case"end":return _context4.stop();}}},null,null,null,Promise);};i=0;case 6:if(!(i<appConfigsDirs.length)){_context5.next=15;break;}_context5.next=9;return _regenerator.default.awrap(_loop(i));case 9:_ret=_context5.sent;if(!(typeof _ret==="object")){_context5.next=12;break;}return _context5.abrupt("return",_ret.v);case 12:i++;_context5.next=6;break;case 15:return _context5.abrupt("return",


false);case 16:case"end":return _context5.stop();}}},null,null,null,Promise);};


var askUserAboutConfigs=function askUserAboutConfigs(c,dir,id,basePath){var _await$inquirer$promp,choice,filePath,fileContents;return _regenerator.default.async(function askUserAboutConfigs$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
(0,_logger.logWarning)("AppConfig error - It seems you have a mismatch between appConfig folder name ("+

dir+") and the id defined in renative.json ("+
id+"). They must match.");if(!(

c.program.ci===true)){_context6.next=3;break;}throw(
new Error(
'You cannot continue if you set --ci flag. please fix above error first'));case 3:_context6.next=5;return _regenerator.default.awrap(


_inquirer.default.prompt({
type:'list',
name:'choice',
message:'You must choose what you want to keep',
choices:[
{
name:"Keep ID from renative.json ("+id+") and rename the folder ("+dir+" -> "+id+")",
value:'keepID'},

{
name:"Keep folder name ("+dir+") and rename the ID from renative.json ("+id+" -> "+dir+")",
value:'keepFolder'},

new _inquirer.default.Separator(),
{
name:"I'll do it manually",
value:'manually'}]}));case 5:_await$inquirer$promp=_context6.sent;choice=_await$inquirer$promp.choice;if(!(




choice==='manually')){_context6.next=9;break;}throw(
new Error('Please do the changes and rerun the command'));case 9:


if(choice==='keepID'){
(0,_fileutils.fsRenameSync)(_path.default.join(basePath,dir),_path.default.join(basePath,id));
}

if(choice==='keepFolder'){
filePath=_path.default.join(basePath,dir,'renative.json');
fileContents=JSON.parse((0,_fileutils.fsReadFileSync)(filePath));
fileContents.id=dir;

(0,_fileutils.writeFileSync)(filePath,fileContents);
}case 11:case"end":return _context6.stop();}}},null,null,null,Promise);};


var taskRnvConfigSet=function taskRnvConfigSet(c,parentTask,originTask){
(0,_logger.logTask)('taskRnvConfigSet',"parent:"+parentTask+" origin:"+originTask);

console.log('DJHDJKDHDK');

return true;
};exports.taskRnvConfigSet=taskRnvConfigSet;var _default=

{
description:'Sets current app config',
fn:taskRnvConfigSet,
task:'setAppConfig',
params:[],
platforms:[]};exports.default=_default;
//# sourceMappingURL=task.rnv.config.set.js.map