var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.taskRnvPlatformConfigure=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _path=_interopRequireDefault(require("path"));
var _logger=require("../core/systemManager/logger");
var _fileutils=require("../core/systemManager/fileutils");
var _common=require("../core/common");
var _schemeParser=require("../core/configManager/schemeParser");
var _platformManager=require("../core/platformManager");
var _packageParser=require("../core/configManager/packageParser");
var _configParser=require("../core/configManager/configParser");
var _pluginManager=require("../core/pluginManager");
var _engineManager=require("../core/engineManager");
var _constants=require("../core/constants");

var _sdkManager=require("../core/sdkManager");


var _runCopyPlatforms=function _runCopyPlatforms(c){return new Promise(function(resolve){
(0,_logger.logTask)('_runCopyPlatforms');var
platform=c.platform;
var copyPlatformTasks=[];

if(platform==='all'){
Object.keys(c.buildConfig.platforms).forEach(function(k){
if((0,_platformManager.isPlatformSupportedSync)(k)){
var ptPath=_path.default.join(
c.paths.project.platformTemplatesDirs[k],""+
k);

var pPath=_path.default.join(
c.paths.project.builds.dir,
c.runtime.appId+"_"+k);

copyPlatformTasks.push(
(0,_fileutils.copyFolderContentsRecursiveSync)(ptPath,pPath,true,false,false,{},
(0,_common.getTimestampPathsConfig)(c,platform),c));

}
});
}else if((0,_platformManager.isPlatformSupportedSync)(platform)){
var ptPath=_path.default.join(
c.paths.project.platformTemplatesDirs[platform],""+
platform);

var pPath=_path.default.join(
c.paths.project.builds.dir,
c.runtime.appId+"_"+platform);

copyPlatformTasks.push(
(0,_fileutils.copyFolderContentsRecursiveSync)(ptPath,pPath,true,false,false,{},
(0,_common.getTimestampPathsConfig)(c,platform),c));

}else{
(0,_logger.logWarning)("Your platform "+
(0,_logger.chalk)().white(
platform)+" config is not present. Check "+
(0,_logger.chalk)().white(
c.paths.appConfig.config));


}

Promise.all(copyPlatformTasks).then(function(){
resolve();
});
});};

var taskRnvPlatformConfigure=function taskRnvPlatformConfigure(c,parentTask,originTask){var hasBuild;return _regenerator.default.async(function taskRnvPlatformConfigure$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('taskRnvPlatformConfigure','');_context.next=3;return _regenerator.default.awrap(

(0,_engineManager.executeTask)(c,_constants.TASK_PROJECT_CONFIGURE,_constants.TASK_PLATFORM_CONFIGURE,originTask));case 3:_context.next=5;return _regenerator.default.awrap(

(0,_platformManager.isPlatformSupported)(c));case 5:_context.next=7;return _regenerator.default.awrap(
(0,_schemeParser.isBuildSchemeSupported)(c));case 7:_context.next=9;return _regenerator.default.awrap(
(0,_sdkManager.checkSdk)(c));case 9:_context.next=11;return _regenerator.default.awrap(
(0,_configParser.configureRuntimeDefaults)(c));case 11:if(!(

c.program.only&&!!parentTask)){_context.next=13;break;}return _context.abrupt("return",true);case 13:_context.next=15;return _regenerator.default.awrap(

(0,_pluginManager.resolvePluginDependants)(c));case 15:_context.next=17;return _regenerator.default.awrap(

(0,_engineManager.executeTask)(c,_constants.TASK_INSTALL,_constants.TASK_PLATFORM_CONFIGURE,originTask));case 17:

hasBuild=(0,_fileutils.fsExistsSync)(c.paths.project.builds.dir);
(0,_logger.logTask)('',"taskRnvPlatformConfigure hasBuildFolderPresent:"+hasBuild);if(!(

c.program.reset||c.program.resetHard)){_context.next=23;break;}
(0,_logger.logInfo)("You passed "+
(0,_logger.chalk)().white(c.program.reset?'-r':'-R')+" argument. \""+(0,_logger.chalk)().white((0,_common.getAppFolder)(c,c.platform))+"\" CLEANING...DONE");_context.next=23;return _regenerator.default.awrap(

(0,_platformManager.cleanPlatformBuild)(c,c.platform));case 23:_context.next=25;return _regenerator.default.awrap(


(0,_platformManager.createPlatformBuild)(c,c.platform));case 25:_context.next=27;return _regenerator.default.awrap(
(0,_packageParser.injectPlatformDependencies)(c));case 27:_context.next=29;return _regenerator.default.awrap(
_runCopyPlatforms(c));case 29:case"end":return _context.stop();}}},null,null,null,Promise);};exports.taskRnvPlatformConfigure=taskRnvPlatformConfigure;var _default=


{
description:'',
fn:taskRnvPlatformConfigure,
task:'platform configure',
params:_constants.PARAMS.withBase(),
platforms:[]};exports.default=_default;
//# sourceMappingURL=task.rnv.platform.configure.js.map