var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.default=exports.taskRnvSetAppConfig=exports.updateConfig=exports.setAppConfig=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _logger=require("../core/systemManager/logger");

var readdirAsync=promisify(fsReaddir);


var _loadAppConfigIDfromDir=function _loadAppConfigIDfromDir(dir,appConfigsDir){
logDebug("_loadAppConfigIDfromDir:"+dir+":"+appConfigsDir,(0,_logger.chalk)().grey);
var filePath=path.join(appConfigsDir,dir,'renative.json');
if(fsExistsSync(filePath)){
try{
var renativeConf=JSON.parse(fsReadFileSync(filePath));
return{dir:dir,id:renativeConf.id};
}catch(e){
logError("File "+filePath+" is MALFORMED:\n"+e);
}
}
return{dir:dir,id:null};
};

var setAppConfig=function setAppConfig(c,appId){var workspaceAppConfigsDir;return _regenerator.default.async(function setAppConfig$(_context){while(1){switch(_context.prev=_context.next){case 0:
(0,_logger.logTask)('setAppConfig',"appId:"+appId);if(!(

!appId||appId===true||appId===true)){_context.next=3;break;}return _context.abrupt("return");case 3:

c.runtime.appId=appId;
c.runtime.appDir=path.join(
c.paths.project.builds.dir,
c.runtime.appId+"_"+c.platform);


_findAndSwitchAppConfigDir(c,appId);

_generateConfigPaths(
c.paths.appConfig,
path.join(c.paths.project.appConfigsDir,appId));

c.paths.appConfig.fontsDir=path.join(c.paths.appConfig.dir,'fonts');
_loadConfigFiles(
c,
c.files.appConfig,
c.paths.appConfig,
c.paths.project.appConfigsDir);


workspaceAppConfigsDir=getRealPath(
c,
c.buildConfig.workspaceAppConfigsDir);

c.paths.workspace.project.appConfigsDir=workspaceAppConfigsDir||
path.join(c.paths.workspace.project.dir,'appConfigs');

_generateConfigPaths(
c.paths.workspace.appConfig,
path.join(c.paths.workspace.project.appConfigsDir,appId));


_loadConfigFiles(
c,
c.files.workspace.appConfig,
c.paths.workspace.appConfig,
c.paths.workspace.project.appConfigsDir);

generateBuildConfig(c);
generateLocalConfig(c);_context.t0=


_generateConfigPaths;_context.t1=
c.paths.workspace;_context.t2=
getRealPath;_context.t3=c;_context.next=21;return _regenerator.default.awrap(getWorkspaceDirPath(c));case 21:_context.t4=_context.sent;_context.t5=(0,_context.t2)(_context.t3,_context.t4);(0,_context.t0)(_context.t1,_context.t5);

_loadConfigFiles(c,c.files.workspace,c.paths.workspace);case 25:case"end":return _context.stop();}}},null,null,null,Promise);};exports.setAppConfig=setAppConfig;


var updateConfig=function updateConfig(c,appConfigId){var isPureRnv,configDirs,_await$inquirerPrompt,_conf,_await$inquirerPrompt2,conf;return _regenerator.default.async(function updateConfig$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:
(0,_logger.logTask)('updateConfig',"appId:"+appConfigId);_context2.next=3;return _regenerator.default.awrap(

setAppConfig(c,appConfigId));case 3:

isPureRnv=!c.command&&!c.subCommand;if(!(

!fsExistsSync(c.paths.appConfig.dir)||isPureRnv)){_context2.next=30;break;}
configDirs=listAppConfigsFoldersSync(c,true);

if(!appConfigId){
logWarning("It seems you don't have any appConfig active");
}else if(appConfigId!==true&&appConfigId!==true&&!isPureRnv){
logWarning("It seems you don't have appConfig named "+
(0,_logger.chalk)().white(
appConfigId)+" present in your config folder: "+
(0,_logger.chalk)().white(
c.paths.project.appConfigsDir)+" !\nchecked path: "+

c.paths.appConfig.dir);

}if(!

configDirs.length){_context2.next=21;break;}if(!(
configDirs.length===1)){_context2.next=13;break;}

logInfo("Found only one app config available. Will use "+
(0,_logger.chalk)().white(
configDirs[0]));_context2.next=12;return _regenerator.default.awrap(


setAppConfig(c,configDirs[0]));case 12:return _context2.abrupt("return",
true);case 13:_context2.next=15;return _regenerator.default.awrap(


inquirerPrompt({
name:'conf',
type:'list',
message:'Which one would you like to pick?',
choices:configDirs,
pageSize:50,
logMessage:'ReNative found multiple existing appConfigs'}));case 15:_await$inquirerPrompt=_context2.sent;_conf=_await$inquirerPrompt.conf;if(!


_conf){_context2.next=21;break;}_context2.next=20;return _regenerator.default.awrap(
setAppConfig(c,_conf));case 20:return _context2.abrupt("return",
true);case 21:_context2.next=23;return _regenerator.default.awrap(



inquirerPrompt({
name:'conf',
type:'confirm',
message:'Do you want ReNative to create new sample appConfig for you?',
warningMessage:"No app configs found for this project \nMaybe you forgot to run "+(0,_logger.chalk)().white('rnv template apply')+" ?"}));case 23:_await$inquirerPrompt2=_context2.sent;conf=_await$inquirerPrompt2.conf;if(!


conf){_context2.next=30;break;}_context2.next=28;return _regenerator.default.awrap(

executeTask(c,TASK_TEMPLATE_APPLY));case 28:_context2.next=30;return _regenerator.default.awrap(

setAppConfig(c));case 30:return _context2.abrupt("return",


true);case 31:case"end":return _context2.stop();}}},null,null,null,Promise);};exports.updateConfig=updateConfig;



var matchAppConfigID=function matchAppConfigID(c,appConfigID){var _c$buildConfig,_c$buildConfig$paths,_c$paths$project;var appConfigsDirs,_loop,i,_ret;return _regenerator.default.async(function matchAppConfigID$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:
(0,_logger.logTask)('matchAppConfigID',"appId:"+appConfigID);if(

appConfigID){_context5.next=3;break;}return _context5.abrupt("return",false);case 3:

appConfigsDirs=((_c$buildConfig=c.buildConfig)==null?void 0:(_c$buildConfig$paths=_c$buildConfig.paths)==null?void 0:_c$buildConfig$paths.appConfigsDirs)||[(_c$paths$project=
c.paths.project)==null?void 0:_c$paths$project.appConfigsDir];_loop=function _loop(



i){var appConfigsDir,appConfigDirContents,appConfigs,ids,dirs,foundConfig;return _regenerator.default.async(function _loop$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:
appConfigsDir=appConfigsDirs[i];if(!
fsExistsSync(appConfigsDir)){_context4.next=17;break;}_context4.t0=_regenerator.default;_context4.next=5;return _regenerator.default.awrap(
readdirAsync(
appConfigsDir));case 5:_context4.t1=_context4.sent.
filter(function(folder){return fsStatSync(path.join(appConfigsDir,folder)).isDirectory();});_context4.next=8;return _context4.t0.awrap.call(_context4.t0,_context4.t1);case 8:appConfigDirContents=_context4.sent;

appConfigs=appConfigDirContents.
map(function(dir){return _loadAppConfigIDfromDir(dir,appConfigsDir);}).
filter(function(conf){return conf.id!==null;});

ids=[];
dirs=[];_context4.next=14;return _regenerator.default.awrap(
Promise.all(
appConfigs.map(function _callee(conf){var id,dir;return _regenerator.default.async(function _callee$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:
id=conf.id.toLowerCase();
dir=conf.dir.toLowerCase();if(!(

id!==dir)){_context3.next=5;break;}_context3.next=5;return _regenerator.default.awrap(
askUserAboutConfigs(
c,
conf.dir,
conf.id,
appConfigsDir));case 5:if(!


ids.includes(id)){_context3.next=7;break;}throw(
new Error("AppConfig error - You have 2 duplicate app configs with ID "+

id+". Keep in mind that ID is case insensitive.\nPlease edit one of them in /appConfigs/<folder>/renative.json"));case 7:




ids.push(id);if(!
dirs.includes(dir)){_context3.next=10;break;}throw(
new Error("AppConfig error - You have 2 duplicate app config folders named "+

dir+". Keep in mind that folder names are case insensitive.\nPlease rename one /appConfigs/<folder>"));case 10:




dirs.push(dir);case 11:case"end":return _context3.stop();}}},null,null,null,Promise);})));case 14:



foundConfig=appConfigs.filter(
function(cfg){return cfg.id===appConfigID||
cfg.id.toLowerCase()===appConfigID||
cfg.dir===appConfigID||
cfg.dir.toLowerCase()===appConfigID;});if(!

foundConfig.length){_context4.next=17;break;}return _context4.abrupt("return",{v:foundConfig[0].id.toLowerCase()});case 17:case"end":return _context4.stop();}}},null,null,null,Promise);};i=0;case 6:if(!(i<appConfigsDirs.length)){_context5.next=15;break;}_context5.next=9;return _regenerator.default.awrap(_loop(i));case 9:_ret=_context5.sent;if(!(typeof _ret==="object")){_context5.next=12;break;}return _context5.abrupt("return",_ret.v);case 12:i++;_context5.next=6;break;case 15:return _context5.abrupt("return",


false);case 16:case"end":return _context5.stop();}}},null,null,null,Promise);};


var askUserAboutConfigs=function askUserAboutConfigs(c,dir,id,basePath){var _await$inquirer$promp,choice,filePath,fileContents;return _regenerator.default.async(function askUserAboutConfigs$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:
logWarning("AppConfig error - It seems you have a mismatch between appConfig folder name ("+

dir+") and the id defined in renative.json ("+
id+"). They must match.");if(!(

c.program.ci===true)){_context6.next=3;break;}throw(
new Error(
'You cannot continue if you set --ci flag. please fix above error first'));case 3:_context6.next=5;return _regenerator.default.awrap(


inquirer.prompt({
type:'list',
name:'choice',
message:'You must choose what you want to keep',
choices:[
{
name:"Keep ID from renative.json ("+id+") and rename the folder ("+dir+" -> "+id+")",
value:'keepID'},

{
name:"Keep folder name ("+dir+") and rename the ID from renative.json ("+id+" -> "+dir+")",
value:'keepFolder'},

new inquirer.Separator(),
{
name:"I'll do it manually",
value:'manually'}]}));case 5:_await$inquirer$promp=_context6.sent;choice=_await$inquirer$promp.choice;if(!(




choice==='manually')){_context6.next=9;break;}throw(
new Error('Please do the changes and rerun the command'));case 9:


if(choice==='keepID'){
fsRenameSync(path.join(basePath,dir),path.join(basePath,id));
}

if(choice==='keepFolder'){
filePath=path.join(basePath,dir,'renative.json');
fileContents=JSON.parse(fsReadFileSync(filePath));
fileContents.id=dir;

writeFileSync(filePath,fileContents);
}case 11:case"end":return _context6.stop();}}},null,null,null,Promise);};


var taskRnvSetAppConfig=function taskRnvSetAppConfig(c,parentTask,originTask){
(0,_logger.logTask)('taskRnvSetAppConfig',"parent:"+parentTask+" origin:"+originTask);

console.log('DJHDJKDHDK');

return true;
};exports.taskRnvSetAppConfig=taskRnvSetAppConfig;var _default=

{
description:'Sets current app config',
fn:taskRnvSetAppConfig,
task:'setAppConfig',
params:[],
platforms:[]};exports.default=_default;
//# sourceMappingURL=task.rnv.setAppConfig.js.map